--
-- Bunker Silo Worker
--
-- @author  LordBanana
-- @date    2023-07-28
--

local directory = g_currentModDirectory .. "/src/"
source(Utils.getFilename("Debug.lua", directory))
source(Utils.getFilename("override.lua", directory))
source(Utils.getFilename("AIDriveStrategyBunkerSilo.lua", directory))

---- Register this specialization
local specTypeName = 'bunkerSiloWorker'

g_specializationManager:addSpecialization(specTypeName, 'BunkerSiloWorker', Utils.getFilename('BunkerSiloWorker.lua', directory), nil)

---- Add the specialization to specific vehicle-types
local modSpecTypeName = specTypeName

for vehTypeName,vehTypeObj in pairs( g_vehicleTypeManager:getTypes() ) do
  if  true  == SpecializationUtil.hasSpecialization(Drivable      ,vehTypeObj.specializations)
  and true  == SpecializationUtil.hasSpecialization(Motorized     ,vehTypeObj.specializations)
  and true  == SpecializationUtil.hasSpecialization(Enterable     ,vehTypeObj.specializations)
  and true  == SpecializationUtil.hasSpecialization(AIVehicle     ,vehTypeObj.specializations)
  and true  == SpecializationUtil.hasSpecialization(Lights        ,vehTypeObj.specializations)
  and false == SpecializationUtil.hasSpecialization(ConveyorBelt  ,vehTypeObj.specializations)
  and false == SpecializationUtil.hasSpecialization(Locomotive    ,vehTypeObj.specializations)
  then
    g_vehicleTypeManager:addSpecialization(vehTypeName, modSpecTypeName)
    Debug.log("  BunkerSiloWorker added to: ",vehTypeName)
  end
end

function mergeModTranslations(i18n)
    -- We can copy all our translations to the global table because we prefix everything with guidanceSteering_
    -- Thanks for blocking the getfenv Giants..
    local modEnvMeta = getmetatable(_G)
    local env = modEnvMeta.__index

    local global = env.g_i18n.texts
    for key, text in pairs(i18n.texts) do
        global[key] = text
    end
end

mergeModTranslations(g_i18n)
