--
-- Bunker Silo Worker
--
-- @author  LordBanana
-- @date    2023-07-28
--

Debug = {}

Debug.active = false;

-- For debugging text
function Debug.log(...)
  if Debug.active then
      local txt = ""
      for idx = 1,select("#", ...) do
          txt = txt .. tostring(select(idx, ...))
      end
      print(txt);
  end
end;

-- For drawing a node, with lines pointing in each axis.
function Debug:drawOrigo(node)
    if Debug.active then
        local x1, y1, z1 = localToWorld(node, 0, 2, 0);
        local x2, y2, z2 = localToWorld(node, 1, 2, 0);
        local x3, y3, z3 = localToWorld(node, 0, 3, 0);
        local x4, y4, z4 = localToWorld(node, 0, 2, 1);

        drawDebugLine(x1, y1, z1,
                      1,1,1,
                      x2, y2, z2,
                      1,0,0,
                      false);
        drawDebugLine(x1, y1, z1,
                      1,1,1,
                      x3, y3, z3,
                      0,1,0,
                      false);
        drawDebugLine(x1, y1, z1,
                      1,1,1,
                      x4, y4, z4,
                      0,0,1,
                      false);
    end;
end;

-- For drawing a rectangle with given coordinates
function Debug:drawRectangle(startWorldX, startWorldZ,
							      widthWorldX, widthWorldZ,
							      heightWorldX, heightWorldZ,
							      worldY,
							      colorR, colorG, colorB)
    if Debug.active then
        drawDebugLine(startWorldX,
                      worldY,
                      startWorldZ,
                      colorR, colorG, colorB,
                      widthWorldX,
                      worldY,
                      widthWorldZ,
                      colorR, colorG, colorB, false);
        drawDebugLine(startWorldX,
                      worldY,
                      startWorldZ,
                      colorR, colorG, colorB,
                      heightWorldX,
                      worldY,
                      heightWorldZ,
                      colorR, colorG, colorB, false);
        drawDebugLine(widthWorldX,
                      worldY,
                      widthWorldZ,
                      colorR, colorG, colorB,
                      widthWorldX + (heightWorldX - startWorldX),
                      worldY,
                      widthWorldZ + (heightWorldZ - startWorldZ),
                      colorR, colorG, colorB, false);
        drawDebugLine(heightWorldX,
                      worldY,
                      heightWorldZ,
                      colorR, colorG, colorB,
                      heightWorldX - (startWorldX - widthWorldX),
                      worldY,
                      heightWorldZ - (startWorldZ - widthWorldZ),
                      colorR, colorG, colorB, false);
    end;
end;